# Generated by Django 2.2.27 on 2022-03-10 15:17

import uuid

import django.db.models.deletion
from django.db import migrations, models

import django_loose_fk.constraints
import django_loose_fk.fields


class Migration(migrations.Migration):
    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="B",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("remote_type", models.URLField(blank=True)),
                (
                    "type",
                    django_loose_fk.fields.FkOrURLField(
                        blank=True,
                        fk_field="local_type",
                        null=False,
                        url_field="remote_type",
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="TypeA",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=50, verbose_name="name")),
            ],
        ),
        migrations.CreateModel(
            name="Zaak",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=50, verbose_name="name")),
                ("extern_zaaktype", models.URLField(blank=True)),
                (
                    "zaaktype",
                    django_loose_fk.fields.FkOrURLField(
                        blank=False,
                        fk_field="_zaaktype",
                        null=False,
                        url_field="extern_zaaktype",
                    ),
                ),
            ],
            options={
                "verbose_name": "zaak",
                "verbose_name_plural": "zaken",
            },
        ),
        migrations.CreateModel(
            name="ZaakType",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=50, verbose_name="name")),
            ],
            options={
                "verbose_name": "zaaktype",
                "verbose_name_plural": "zaaktypen",
            },
        ),
        migrations.CreateModel(
            name="ZaakObject",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=50, verbose_name="name")),
                ("extern_zaak", models.URLField(blank=True)),
                (
                    "zaak",
                    django_loose_fk.fields.FkOrURLField(
                        blank=False,
                        fk_field="_zaak",
                        null=False,
                        url_field="extern_zaak",
                    ),
                ),
                (
                    "_zaak",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.PROTECT,
                        to="testapp.Zaak",
                    ),
                ),
            ],
        ),
        migrations.AddField(
            model_name="zaak",
            name="_zaaktype",
            field=models.ForeignKey(
                blank=True,
                null=True,
                on_delete=django.db.models.deletion.PROTECT,
                to="testapp.ZaakType",
            ),
        ),
        migrations.CreateModel(
            name="TypeB",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=50, verbose_name="name")),
                ("uuid", models.UUIDField(default=uuid.uuid4)),
                ("a_types", models.ManyToManyField(blank=True, to="testapp.TypeA")),
            ],
        ),
        migrations.CreateModel(
            name="DummyModel",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("extern_zaaktype1", models.URLField(blank=True)),
                (
                    "zaaktype1",
                    django_loose_fk.fields.FkOrURLField(
                        blank=False,
                        fk_field="_zaaktype1",
                        null=False,
                        url_field="extern_zaaktype1",
                    ),
                ),
                ("extern_zaaktype2", models.URLField(blank=True)),
                (
                    "zaaktype2",
                    django_loose_fk.fields.FkOrURLField(
                        blank=True,
                        fk_field="_zaaktype2",
                        null=True,
                        url_field="extern_zaaktype2",
                    ),
                ),
                (
                    "_zaaktype1",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.PROTECT,
                        related_name="+",
                        to="testapp.ZaakType",
                    ),
                ),
                (
                    "_zaaktype2",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.PROTECT,
                        related_name="+",
                        to="testapp.ZaakType",
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="C",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("remote_b", models.URLField(blank=True)),
                (
                    "b",
                    django_loose_fk.fields.FkOrURLField(
                        blank=False,
                        fk_field="local_b",
                        null=False,
                        url_field="remote_b",
                    ),
                ),
                (
                    "local_b",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        to="testapp.B",
                    ),
                ),
            ],
        ),
        migrations.AddField(
            model_name="b",
            name="local_type",
            field=models.ForeignKey(
                blank=True,
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                to="testapp.TypeB",
            ),
        ),
        migrations.AddConstraint(
            model_name="zaakobject",
            constraint=django_loose_fk.constraints.FkOrURLFieldConstraint(
                fk_field="_zaak", url_field="extern_zaak"
            ),
        ),
        migrations.AddConstraint(
            model_name="zaak",
            constraint=django_loose_fk.constraints.FkOrURLFieldConstraint(
                fk_field="_zaaktype", url_field="extern_zaaktype"
            ),
        ),
        migrations.AddConstraint(
            model_name="dummymodel",
            constraint=django_loose_fk.constraints.FkOrURLFieldConstraint(
                fk_field="_zaaktype1", url_field="extern_zaaktype1"
            ),
        ),
        migrations.AddConstraint(
            model_name="c",
            constraint=django_loose_fk.constraints.FkOrURLFieldConstraint(
                fk_field="local_b", url_field="remote_b"
            ),
        ),
        migrations.AddConstraint(
            model_name="b",
            constraint=django_loose_fk.constraints.FkOrURLFieldConstraint(
                fk_field="local_type", url_field="remote_type"
            ),
        ),
    ]
